#include "lib.h"
#include "network.h"

/* UDP is defined in RFC 768. */

struct udp_header {
	unsigned short sport;
	unsigned short dport;
	unsigned short length;
	unsigned short checksum;
} __attribute__ ((packed));

void udp_transmit(const unsigned char *dstmac, const unsigned char *dstip,
		  unsigned short dstport, unsigned short srcport,
		  const void *pkg, unsigned int pkglen)
{
	int rpllen = sizeof(struct pseudo_header) + sizeof(struct udp_header) +
		pkglen;
	struct pseudo_header *pseudo_header;
	struct udp_header *udp_header;
	char rpl[rpllen];
	pseudo_header = (void *) rpl;
	udp_header = ((void *) rpl) + sizeof(struct pseudo_header);

	/* fill all headers */
	memcpy(pseudo_header->sip, ip_addr, 4);
	memcpy(pseudo_header->dip, dstip, 4);
	pseudo_header->zero = 0;
	pseudo_header->ptcl = IP_UDP;
	pseudo_header->length = htons(rpllen - sizeof(struct pseudo_header));
	udp_header->sport = srcport;
	udp_header->dport = dstport;
	udp_header->length = htons(rpllen - sizeof(struct pseudo_header));
	udp_header->checksum = 0;

	/* copy data */
	memcpy(&rpl[rpllen - pkglen], pkg, pkglen);

	/* compute checksum */
	udp_header->checksum = create_checksum(rpl, rpllen);

	/* transmit */
	ip_transmit(dstmac, dstip, IP_UDP, rpl + sizeof(struct pseudo_header),
		    rpllen - sizeof(struct pseudo_header));
}
